diff -urN ../VisualBoyAdvance-1.7.2/src/prof/prof.cpp ./src/prof/prof.cpp
--- ../VisualBoyAdvance-1.7.2/src/prof/prof.cpp	2004-05-13 23:31:58 +0900
+++ ./src/prof/prof.cpp	2006-08-25 23:13:38 +0900
@@ -57,20 +57,14 @@
 #include "../GBA.h"
 #include "../NLS.h"
 
+#include "prof.h" /* for struct profile_segment */
+
 /*
  * froms is actually a bunch of unsigned shorts indexing tos
  */
 static int  profiling = 3;
-static unsigned short *froms;
-static struct tostruct *tos = 0;
-static long  tolimit = 0;
-static u32  s_lowpc = 0;
-static u32  s_highpc = 0;
-static unsigned long s_textsize = 0;
-
-static int ssiz;
-static char *sbuf;
-static int s_scale;
+
+static profile_segment *first_segment = NULL;
 
 static int hz = 0;
 static int hist_num_bins = 0;
@@ -127,13 +121,13 @@
   if (mode) {
     /* start */
 #ifdef PROFILING
-    cpuProfil(sbuf, ssiz, (u32)s_lowpc, s_scale);
+    cpuProfil(first_segment);
 #endif
     profiling = 0;
   } else {
     /* stop */
 #ifdef PROFILING
-    cpuProfil(NULL, 0, 0, 0);
+    cpuProfil(NULL);
 #endif
     profiling = 3;
   }
@@ -147,57 +141,65 @@
   int monsize;
   char *buffer;
   int o;
+  profile_segment *newseg = (profile_segment*)calloc(1,sizeof(profile_segment));
   
+  if (newseg) {
+    newseg->next = first_segment;
+    first_segment = newseg;
+  } else {
+    systemMessage(0, MSG);
+    return;
+  }
   /*
    * round lowpc and highpc to multiples of the density we're using
    * so the rest of the scaling (here and in gprof) stays in ints.
    */
   lowpc = ROUNDDOWN(lowpc, HISTFRACTION*sizeof(HISTCOUNTER));
-  s_lowpc = lowpc;
+  newseg->s_lowpc = lowpc;
   highpc = ROUNDUP(highpc, HISTFRACTION*sizeof(HISTCOUNTER));
-  s_highpc = highpc;
-  s_textsize = highpc - lowpc;
-  monsize = (s_textsize / HISTFRACTION);
+  newseg->s_highpc = highpc;
+  newseg->s_textsize = highpc - lowpc;
+  monsize = (newseg->s_textsize / HISTFRACTION);
   buffer = (char *)calloc(1, 2*monsize );
   if ( buffer == NULL ) {
     systemMessage(0, MSG);
     return;
   }
-  froms = (unsigned short *) calloc(1, 4*s_textsize / HASHFRACTION );
-  if ( froms == NULL ) {
+  newseg->froms = (unsigned short *) calloc(1, 4*newseg->s_textsize / HASHFRACTION );
+  if ( newseg->froms == NULL ) {
     systemMessage(0, MSG);
     free(buffer);
     buffer = NULL;
     return;
   }
-  tolimit = s_textsize * ARCDENSITY / 100;
-  if ( tolimit < MINARCS ) {
-    tolimit = MINARCS;
-  } else if ( tolimit > 65534 ) {
-    tolimit = 65534;
+  newseg->tolimit = newseg->s_textsize * ARCDENSITY / 100;
+  if ( newseg->tolimit < MINARCS ) {
+    newseg->tolimit = MINARCS;
+  } else if ( newseg->tolimit > 65534 ) {
+    newseg->tolimit = 65534;
   }
-  tos = (struct tostruct *) calloc(1, tolimit * sizeof( struct tostruct ) );
-  if ( tos == NULL ) {
+  newseg->tos = (struct tostruct *) calloc(1, newseg->tolimit * sizeof( struct tostruct ) );
+  if ( newseg->tos == NULL ) {
     systemMessage(0, MSG);
     
     free(buffer);
     buffer = NULL;
     
-    free(froms);
-    froms = NULL;
+    free(newseg->froms);
+    newseg->froms = NULL;
     
     return;
   }
-  tos[0].link = 0;
-  sbuf = buffer;
-  ssiz = monsize;
+  newseg->tos[0].link = 0;
+  newseg->sbuf = buffer;
+  newseg->ssiz = monsize;
   if ( monsize <= 0 )
     return;
   o = highpc - lowpc;
   if( monsize < o )
-    s_scale = (int)(( (float) monsize / o ) * SCALE_1_TO_1);
+    newseg->s_scale = (int)(( (float) monsize / o ) * SCALE_1_TO_1);
   else
-    s_scale = SCALE_1_TO_1;
+    newseg->s_scale = SCALE_1_TO_1;
   profControl(1);
 }
 
@@ -209,6 +211,7 @@
   u32 frompc;
   int toindex;
   struct gmon_hdr ghdr;
+  profile_segment *seg = first_segment;
   
   profControl(0);
   fd = fopen( "gmon.out" , "wb" );
@@ -229,11 +232,13 @@
   if(hz == 0)
     hz = 100;
 
-  hist_num_bins = ssiz;
+  while(seg) {
+
+    hist_num_bins = seg->ssiz;
   
   if(profWrite8(fd, GMON_TAG_TIME_HIST) ||
-     profWrite32(fd, (u32)s_lowpc) ||
-     profWrite32(fd, (u32)s_highpc) ||
+       profWrite32(fd, (u32)seg->s_lowpc) ||
+       profWrite32(fd, (u32)seg->s_highpc) ||
      profWrite32(fd, hist_num_bins) ||
      profWrite32(fd, hz) ||
      profWrite(fd, hist_dimension, 15) ||
@@ -242,7 +247,7 @@
     fclose(fd);
     return;
   }
-  u16 *hist_sample = (u16 *)sbuf;
+    u16 *hist_sample = (u16 *)seg->sbuf;
 
   u16 count;
   int i;
@@ -257,23 +262,25 @@
     }
   }
   
-  endfrom = s_textsize / (HASHFRACTION * sizeof(*froms));
+    endfrom = seg->s_textsize / (HASHFRACTION * sizeof(*seg->froms));
   for ( fromindex = 0 ; fromindex < endfrom ; fromindex++ ) {
-    if ( froms[fromindex] == 0 ) {
+      if ( seg->froms[fromindex] == 0 ) {
       continue;
     }
-    frompc = s_lowpc + (fromindex * HASHFRACTION * sizeof(*froms));
-    for (toindex=froms[fromindex]; toindex!=0; toindex=tos[toindex].link) {
+      frompc = seg->s_lowpc + (fromindex * HASHFRACTION * sizeof(*seg->froms));
+      for (toindex=seg->froms[fromindex]; toindex!=0; toindex=seg->tos[toindex].link) {
       if(profWrite8(fd, GMON_TAG_CG_ARC) ||
          profWrite32(fd, (u32)frompc) ||
-         profWrite32(fd, (u32)tos[toindex].selfpc) ||
-         profWrite32(fd, tos[toindex].count)) {
+	   profWrite32(fd, (u32)seg->tos[toindex].selfpc) ||
+	   profWrite32(fd, seg->tos[toindex].count)) {
         systemMessage(0, "mcount: arc");
         fclose(fd);
         return;
       }
     }
   }
+    seg = seg->next;
+  }
   fclose(fd);
 }
 
@@ -284,6 +291,7 @@
   register struct tostruct *top;
   register struct tostruct *prevtop;
   register long toindex;
+  profile_segment *seg = first_segment;
 
   /*
    * find the return address for mcount,
@@ -309,29 +317,36 @@
    * for example: signal catchers get called from the stack,
    *   not from text space.  too bad.
    */
-  frompcindex = (unsigned short *) ((long) frompcindex - (long) s_lowpc);
-  if ((unsigned long) frompcindex > s_textsize) {
+  while(seg) {
+    u32 index = (long)frompcindex - (long)seg->s_lowpc;
+    if (index <= seg->s_textsize) {
+      frompcindex = (unsigned short *) index;
+      break;
+    }
+    seg = seg->next;
+  }
+  if ((unsigned long) frompcindex > seg->s_textsize) {
     goto done;
   }
   frompcindex =
-    &froms[((long) frompcindex) / (HASHFRACTION * sizeof(*froms))];
+    &(seg->froms[((long) frompcindex) / (HASHFRACTION * sizeof(*seg->froms))]);
   toindex = *frompcindex;
   if (toindex == 0) {
     /*
      * first time traversing this arc
      */
-    toindex = ++tos[0].link;
-    if (toindex >= tolimit) {
+    toindex = ++seg->tos[0].link;
+    if (toindex >= seg->tolimit) {
       goto overflow;
     }
     *frompcindex = (unsigned short)toindex;
-    top = &tos[toindex];
+    top = &seg->tos[toindex];
     top->selfpc = selfpc;
     top->count = 1;
     top->link = 0;
     goto done;
   }
-  top = &tos[toindex];
+  top = &seg->tos[toindex];
   if (top->selfpc == selfpc) {
     /*
      * arc at front of chain; usual case.
@@ -353,11 +368,11 @@
        * so we allocate a new tostruct
        * and link it to the head of the chain.
        */
-      toindex = ++tos[0].link;
-      if (toindex >= tolimit) {
+      toindex = ++seg->tos[0].link;
+      if (toindex >= seg->tolimit) {
         goto overflow;
       }
-      top = &tos[toindex];
+      top = &seg->tos[toindex];
       top->selfpc = selfpc;
       top->count = 1;
       top->link = *frompcindex;
@@ -368,7 +383,7 @@
      * otherwise, check the next arc on the chain.
      */
     prevtop = top;
-    top = &tos[top->link];
+    top = &seg->tos[top->link];
     if (top->selfpc == selfpc) {
       /*
        * there it is.
diff -urN ../VisualBoyAdvance-1.7.2/src/prof/prof.h ./src/prof/prof.h
--- ../VisualBoyAdvance-1.7.2/src/prof/prof.h	2004-05-13 22:49:00 +0900
+++ ./src/prof/prof.h	2006-08-25 23:13:38 +0900
@@ -24,6 +24,24 @@
    profiling is what mcount checks to see if
    all the data structures are ready.  */
 
+
+typedef struct profile_segment {
+  unsigned short *froms;
+  struct tostruct *tos;
+  long  tolimit;
+
+  u32  s_lowpc;
+  u32  s_highpc;
+  unsigned long s_textsize;
+  
+  int ssiz;
+  char *sbuf;
+  int s_scale;
+  
+  struct profile_segment *next;
+
+} profile_segment;
+
 extern void profControl(int mode);
 extern void profStartup(u32 lowpc, u32 highpc);
 extern void profCleanup();
diff -urN ../VisualBoyAdvance-1.7.2/src/remote.cpp ./src/remote.cpp
--- ../VisualBoyAdvance-1.7.2/src/remote.cpp	2004-05-21 02:24:47 +0900
+++ ./src/remote.cpp	2006-09-04 06:52:25 +0900
@@ -20,7 +20,7 @@
 #include <stdio.h>
 #include <string.h>
 
-#ifndef WIN32
+#ifndef _WIN32
 # include <unistd.h>
 # include <sys/socket.h>
 # include <netdb.h>
@@ -32,14 +32,15 @@
 # else // ! HAVE_ARPA_INET_H
 #  define socklen_t int
 # endif // ! HAVE_ARPA_INET_H
-#else // WIN32
+# define SOCKET int
+#else // _WIN32
 # include <winsock.h>
 # include <io.h>
 # define socklen_t int
 # define close closesocket
 # define read _read
 # define write _write
-#endif // WIN32
+#endif // _WIN32
 
 #include "GBA.h"
 
@@ -54,8 +55,8 @@
 
 int remotePort = 55555;
 int remoteSignal = 5;
-int remoteSocket = -1;
-int remoteListenSocket = -1;
+SOCKET remoteSocket = -1;
+SOCKET remoteListenSocket = -1;
 bool remoteConnected = false;
 bool remoteResumed = false;
 
@@ -85,11 +86,11 @@
 bool remoteTcpInit()
 {
   if(remoteSocket == -1) {
-#ifdef WIN32
+#ifdef _WIN32
     WSADATA wsaData;
     int error = WSAStartup(MAKEWORD(1,1),&wsaData);
-#endif // WIN32
-    int s = socket(PF_INET, SOCK_STREAM, 0);
+#endif // _WIN32
+    SOCKET s = socket(PF_INET, SOCK_STREAM, 0);
     
     remoteListenSocket = s;
     
@@ -131,19 +132,19 @@
     }
     socklen_t len = sizeof(addr);
 
-#ifdef WIN32
+#ifdef _WIN32
     int flag = 0;    
     ioctlsocket(s, FIONBIO, (unsigned long *)&flag);
-#endif // WIN32
-    int s2 = accept(s, (sockaddr *)&addr, &len);
+#endif // _WIN32
+    SOCKET s2 = accept(s, (sockaddr *)&addr, &len);
     if(s2 > 0) {
       fprintf(stderr, "Got a connection from %s %d\n",
               inet_ntoa((in_addr)addr.sin_addr),
               ntohs(addr.sin_port));
     } else {
-#ifdef WIN32
+#ifdef _WIN32
       int error = WSAGetLastError();
-#endif // WIN32
+#endif // _WIN32
     }
     char dummy;
     recv(s2, &dummy, 1, 0);
@@ -230,14 +231,14 @@
   char *hex = "0123456789abcdef";  
   char buffer[1024];
 
-  int count = strlen(packet);
+  size_t count = strlen(packet);
 
   unsigned char csum = 0;
 
   char *p = buffer;
   *p++ = '$';
   
-  for(int i = 0 ;i < count; i++) {
+  for(size_t i = 0 ;i < count; i++) {
     csum += packet[i];
     *p++ = packet[i];
   }
@@ -246,7 +247,7 @@
   *p++ = hex[csum & 15];
   *p++ = 0;
   //  printf("Sending %s\n", buffer);
-  remoteSendFnc(buffer, count + 4);
+  remoteSendFnc(buffer, (int)count + 4);
 
   char c = 0;
   remoteRecvFnc(&c, 1);
diff -urN ../VisualBoyAdvance-1.7.2/src/sdl/SDL.cpp ./src/sdl/SDL.cpp
--- ../VisualBoyAdvance-1.7.2/src/sdl/SDL.cpp	2004-05-22 05:16:58 +0900
+++ ./src/sdl/SDL.cpp	2006-08-25 23:06:01 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -23,34 +23,34 @@
 #include <sys/types.h>
 #include <sys/stat.h>
 
-#include "AutoBuild.h"
+#include "../AutoBuild.h"
 
 #include "SDL.h"
-#include "GBA.h"
-#include "agbprint.h"
-#include "Flash.h"
-#include "Port.h"
+#include "../GBA.h"
+#include "../agbprint.h"
+#include "../Flash.h"
+#include "../Port.h"
 #include "debugger.h"
-#include "RTC.h"
-#include "Sound.h"
-#include "Text.h"
-#include "unzip.h"
-#include "Util.h"
-#include "gb/GB.h"
-#include "gb/gbGlobals.h"
+#include "../RTC.h"
+#include "../Sound.h"
+#include "../Text.h"
+#include "../unzip.h"
+#include "../Util.h"
+#include "../gb/GB.h"
+#include "../gb/gbGlobals.h"
 
-#ifndef WIN32
+#ifndef _WIN32
 # include <unistd.h>
 # define GETCWD getcwd
-#else // WIN32
+#else // _WIN32
 # include <direct.h>
 # define GETCWD _getcwd
-#endif // WIN32
+#endif // _WIN32
 
 #ifndef __GNUC__
 # define HAVE_DECL_GETOPT 0
 # define __STDC__ 1
-# include "getopt.h"
+# include "../getopt.h"
 #else // ! __GNUC__
 # define HAVE_DECL_GETOPT 1
 # include "getopt.h"
@@ -109,6 +109,7 @@
 extern void debuggerOutput(char *, u32);
 
 extern void CPUUpdateRenderBuffers(bool);
+extern int gbHardware;
 
 struct EmulatedSystem emulator = {
   NULL,
@@ -186,6 +187,7 @@
 static int rewindTimer = 0;
 
 #define REWIND_SIZE 400000
+#define SYSMSG_BUFFER_SIZE 1024
 
 #define _stricmp strcasecmp
 
@@ -231,6 +233,7 @@
 int sdlAutoIPS = 1;
 int sdlRtcEnable = 0;
 int sdlAgbPrint = 0;
+int sdlMirroringEnable = 0;
 
 int sdlDefaultJoypad = 0;
 
@@ -248,8 +251,10 @@
 char screenMessageBuffer[21];
 u32  screenMessageTime = 0;
 
-SDL_cond *cond = NULL;
-SDL_mutex *mutex = NULL;
+// Patch #1382692 by deathpudding.
+SDL_sem *sdlBufferLock  = NULL;
+SDL_sem *sdlBufferFull  = NULL;
+SDL_sem *sdlBufferEmpty = NULL;
 u8 sdlBuffer[4096];
 int sdlSoundLen = 0;
 
@@ -862,15 +867,15 @@
   char buffer[4096];
   char path[2048];
 
-#ifdef WIN32
+#ifdef _WIN32
 #define PATH_SEP ";"
 #define FILE_SEP '\\'
 #define EXE_NAME "VisualBoyAdvance-SDL.exe"
-#else // ! WIN32
+#else // ! _WIN32
 #define PATH_SEP ":"
 #define FILE_SEP '/'
 #define EXE_NAME "VisualBoyAdvance"
-#endif // ! WIN32
+#endif // ! _WIN32
 
   fprintf(stderr, "Searching for file %s\n", name);
   
@@ -893,7 +898,7 @@
       return f;
   }
 
-#ifdef WIN32
+#ifdef _WIN32
   home = getenv("USERPROFILE");
   if(home != NULL) {
     fprintf(stderr, "Searching user profile directory: %s\n", home);
@@ -902,13 +907,13 @@
     if(f != NULL)
       return f;
   }
-#else // ! WIN32
+#else // ! _WIN32
     fprintf(stderr, "Searching system config directory: %s\n", SYSCONFDIR);
     sprintf(path, "%s%c%s", SYSCONFDIR, FILE_SEP, name);
     f = fopen(path, "r");
     if(f != NULL)
       return f;
-#endif // ! WIN32
+#endif // ! _WIN32
 
   if(!strchr(arg0, '/') &&
      !strchr(arg0, '\\')) {
@@ -1204,8 +1209,6 @@
       if(rewindTimer < 0 || rewindTimer > 600)
         rewindTimer = 0;
       rewindTimer *= 6;  // convert value to 10 frames multiple
-    } else if(!strcmp(key, "enhancedDetection")) {
-      cpuEnhancedDetection = sdlFromHex(value) ? true : false;
     } else {
       fprintf(stderr, "Unknown configuration key %s\n", key);
     }
@@ -1306,6 +1309,8 @@
         int save = atoi(value);
         if(save >= 0 && save <= 5)
           cpuSaveType = save;
+      } else if(!strcmp(token, "mirroringEnabled")) {
+        mirroringEnable = (atoi(value) == 0 ? false : true);
       }
     }
   }
@@ -1353,10 +1358,14 @@
             num+1);
   else
     sprintf(stateName,"%s%d.sgm", filename, num+1);
+  
   if(emulator.emuWriteState)
     emulator.emuWriteState(stateName);
+
   sprintf(stateName, "Wrote state %d", num+1);
   systemScreenMessage(stateName);
+
+  systemDrawScreen();
 }
 
 void sdlReadState(int num)
@@ -1374,6 +1383,8 @@
 
   sprintf(stateName, "Loaded state %d", num+1);
   systemScreenMessage(stateName);
+
+  systemDrawScreen();
 }
 
 void sdlWriteBattery()
@@ -1720,7 +1731,7 @@
            (event.key.keysym.mod & KMOD_CTRL)) {
           if(emulating && emulator.emuReadMemState && rewindMemory 
              && rewindCount) {
-            rewindPos = --rewindPos & 7;
+            rewindPos = (rewindPos - 1) & 7;
             emulator.emuReadMemState(&rewindMemory[REWIND_SIZE*rewindPos], 
                                      REWIND_SIZE);
             rewindCount--;
@@ -2182,6 +2193,12 @@
 
   if(optind < argc) {
     char *szFile = argv[optind];
+    u32 len = strlen(szFile);
+    if (len > SYSMSG_BUFFER_SIZE) 
+    {
+      fprintf(stderr,"%s :%s: File name too long\n",argv[0],szFile);
+      exit(-1);
+    }
 
     utilGetBaseName(szFile, filename);
     char *p = strrchr(filename, '.');
@@ -2205,7 +2222,23 @@
     if(type == IMAGE_GB) {
       failed = !gbLoadRom(szFile);
       if(!failed) {
-        cartridgeType = 1;
+        gbGetHardwareType();
+        
+        // used for the handling of the gb Boot Rom
+        if (gbHardware & 5)
+        {
+			    char tempName[0x800];
+			    strcpy(tempName, arg0);
+			    char *p = strrchr(tempName, '\\');
+			    if(p) { *p = 0x00; }
+			    strcat(tempName, "\\DMG_ROM.bin");
+          fprintf(stderr, "%s\n", tempName);
+			    gbCPUInit(tempName, useBios);
+        }
+        else useBios = false;
+        
+        gbReset();
+        cartridgeType = IMAGE_GB;
         emulator = GBSystem;
         if(sdlAutoIPS) {
           int size = gbRomSize;
@@ -2221,11 +2254,9 @@
       int size = CPULoadRom(szFile);
       failed = (size == 0);
       if(!failed) {
-        //        if(cpuEnhancedDetection && cpuSaveType == 0) {
-        //          utilGBAFindSave(rom, size);
-        //        }
-
         sdlApplyPerImagePreferences();
+
+        doMirroring(mirroringEnable);
         
         cartridgeType = 0;
         emulator = GBASystem;
@@ -2262,7 +2293,7 @@
     paletteRAM = (u8 *)calloc(1,0x400);
     vram = (u8 *)calloc(1, 0x20000);
     oam = (u8 *)calloc(1, 0x400);
-    pix = (u8 *)calloc(1, 4 * 240 * 160);
+    pix = (u8 *)calloc(1, 4 * 241 * 162);
     ioMem = (u8 *)calloc(1, 0x400);
 
     emulator = GBASystem;
@@ -2376,43 +2407,22 @@
   if(systemColorDepth == 16) {
     if(sdlCalculateMaskWidth(surface->format->Gmask) == 6) {
       Init_2xSaI(565);
-      RGB_LOW_BITS_MASK = 0x821;
     } else {
       Init_2xSaI(555);
-      RGB_LOW_BITS_MASK = 0x421;      
-    }
-    if(cartridgeType == 2) {
-      for(int i = 0; i < 0x10000; i++) {
-        systemColorMap16[i] = (((i >> 1) & 0x1f) << systemBlueShift) |
-          (((i & 0x7c0) >> 6) << systemGreenShift) |
-          (((i & 0xf800) >> 11) << systemRedShift);  
-      }      
-    } else {
-      for(int i = 0; i < 0x10000; i++) {
-        systemColorMap16[i] = ((i & 0x1f) << systemRedShift) |
-          (((i & 0x3e0) >> 5) << systemGreenShift) |
-          (((i & 0x7c00) >> 10) << systemBlueShift);  
-      }
     }
     srcPitch = srcWidth * 2+4;
   } else {
     if(systemColorDepth != 32)
       filterFunction = NULL;
-    RGB_LOW_BITS_MASK = 0x010101;
-    if(systemColorDepth == 32) {
-      Init_2xSaI(32);
-    }
-    for(int i = 0; i < 0x10000; i++) {
-      systemColorMap32[i] = ((i & 0x1f) << systemRedShift) |
-        (((i & 0x3e0) >> 5) << systemGreenShift) |
-        (((i & 0x7c00) >> 10) << systemBlueShift);  
-    }
+    Init_2xSaI(32);
     if(systemColorDepth == 32)
       srcPitch = srcWidth*4 + 4;
     else
       srcPitch = srcWidth*3;
   }
 
+  utilUpdateSystemColorMaps();
+
   if(systemColorDepth != 32) {
     switch(filter) {
     case 0:
@@ -2568,9 +2578,9 @@
           if(emulator.emuWriteMemState &&
              emulator.emuWriteMemState(&rewindMemory[rewindPos*REWIND_SIZE], 
                                        REWIND_SIZE)) {
-            rewindPos = ++rewindPos & 7;
+            rewindPos = (rewindPos + 1) & 7;
             if(rewindCount == 8)
-              rewindTopPos = ++rewindTopPos & 7;
+              rewindTopPos = (rewindTopPos + 1) & 7;
           }
         }
 
@@ -2608,7 +2618,7 @@
 
 void systemMessage(int num, const char *msg, ...)
 {
-  char buffer[2048];
+  char buffer[SYSMSG_BUFFER_SIZE*2];
   va_list valist;
   
   va_start(valist, msg);
@@ -2914,67 +2924,69 @@
 
 void soundCallback(void *,u8 *stream,int len)
 {
-  if(!emulating)
+  if (!emulating)
     return;
-  SDL_mutexP(mutex);
-  //  printf("Locked mutex\n");
-  if(!speedup && !throttle) {
-    while(sdlSoundLen < 2048*2) {
-      if(emulating)
-        SDL_CondWait(cond, mutex);
-      else 
-        break;
-    }
-  }
-  if(emulating) {
-    //  printf("Copying data\n");
-    memcpy(stream, sdlBuffer, len);
-  }
+
+  // Patch #1382692 by deathpudding.
+  /* since this is running in a different thread, speedup and
+   * throttle can change at any time; save the value so locks
+   * stay in sync */
+  bool lock = (!speedup && !throttle) ? true : false;
+
+  if (lock)
+    SDL_SemWait (sdlBufferFull);
+
+  SDL_SemWait (sdlBufferLock);
+  memcpy (stream, sdlBuffer, len);
   sdlSoundLen = 0;
-  if(mutex)
-    SDL_mutexV(mutex);
+  SDL_SemPost (sdlBufferLock);
+
+  if (lock)
+    SDL_SemPost (sdlBufferEmpty);
 }
 
 void systemWriteDataToSoundBuffer()
 {
-  if(SDL_GetAudioStatus() != SDL_AUDIO_PLAYING)
-    SDL_PauseAudio(0);
-  bool cont = true;
-  while(cont && !speedup && !throttle) {
-    SDL_mutexP(mutex);
-    //    printf("Waiting for len < 2048 (speed up %d)\n", speedup);
-    if(sdlSoundLen < 2048*2)
-      cont = false;
-    SDL_mutexV(mutex);
-  }
-
-  int len = soundBufferLen;
-  int copied = 0;
-  if((sdlSoundLen+len) >= 2048*2) {
-    //    printf("Case 1\n");
-    memcpy(&sdlBuffer[sdlSoundLen],soundFinalWave, 2048*2-sdlSoundLen);
-    copied = 2048*2 - sdlSoundLen;
+  // Patch #1382692 by deathpudding.
+  if (SDL_GetAudioStatus () != SDL_AUDIO_PLAYING)
+    SDL_PauseAudio (0);
+
+  if ((sdlSoundLen + soundBufferLen) >= 2048*2) {
+    bool lock = (!speedup && !throttle) ? true : false;
+
+    if (lock)
+      SDL_SemWait (sdlBufferEmpty);
+
+    SDL_SemWait (sdlBufferLock);
+    int copied = 2048*2 - sdlSoundLen;
+    memcpy (sdlBuffer + sdlSoundLen, soundFinalWave, copied);
     sdlSoundLen = 2048*2;
-    SDL_CondSignal(cond);
-    cont = true;
-    if(!speedup && !throttle) {
-      while(cont) {
-        SDL_mutexP(mutex);
-        if(sdlSoundLen < 2048*2)
-          cont = false;
-        SDL_mutexV(mutex);
-      }
-      memcpy(&sdlBuffer[0],&(((u8 *)soundFinalWave)[copied]),
-             soundBufferLen-copied);
-      sdlSoundLen = soundBufferLen-copied;
-    } else {
-      memcpy(&sdlBuffer[0], &(((u8 *)soundFinalWave)[copied]), 
-soundBufferLen);
-    }
-  } else {
-    //    printf("case 2\n");
-    memcpy(&sdlBuffer[sdlSoundLen], soundFinalWave, soundBufferLen);
-    sdlSoundLen += soundBufferLen;
+    SDL_SemPost (sdlBufferLock);
+
+    if (lock) {
+      SDL_SemPost (sdlBufferFull);
+
+      /* wait for buffer to be dumped by soundCallback() */
+      SDL_SemWait (sdlBufferEmpty);
+      SDL_SemPost (sdlBufferEmpty);
+
+      SDL_SemWait (sdlBufferLock);
+      memcpy (sdlBuffer, ((u8 *)soundFinalWave) + copied,
+          soundBufferLen - copied);
+      sdlSoundLen = soundBufferLen - copied;
+      SDL_SemPost (sdlBufferLock);
+    }
+    else {
+      SDL_SemWait (sdlBufferLock);
+      memcpy (sdlBuffer, ((u8 *) soundFinalWave) + copied, soundBufferLen);
+      SDL_SemPost (sdlBufferLock);
+    }
+  }
+  else {
+    SDL_SemWait (sdlBufferLock);
+    memcpy (sdlBuffer + sdlSoundLen, soundFinalWave, soundBufferLen);
+     sdlSoundLen += soundBufferLen;
+    SDL_SemPost (sdlBufferLock);
   }
 }
 
@@ -3006,8 +3018,10 @@
     return false;
   }
   soundBufferTotalLen = soundBufferLen*10;
-  cond = SDL_CreateCond();
-  mutex = SDL_CreateMutex();
+  // Patch #1382692 by deathpudding.
+  sdlBufferLock  = SDL_CreateSemaphore (1);
+  sdlBufferFull  = SDL_CreateSemaphore (0);
+  sdlBufferEmpty = SDL_CreateSemaphore (1);
   sdlSoundLen = 0;
   systemSoundOn = true;
   return true;
@@ -3015,14 +3029,14 @@
 
 void systemSoundShutdown()
 {
-  SDL_mutexP(mutex);
-  SDL_CondSignal(cond);
-  SDL_mutexV(mutex);
-  SDL_DestroyCond(cond);
-  cond = NULL;
-  SDL_DestroyMutex(mutex);
-  mutex = NULL;
-  SDL_CloseAudio();
+  // Patch #1382692 by deathpudding.
+  SDL_CloseAudio (); //TODO: fix freeze
+  SDL_DestroySemaphore (sdlBufferLock);
+  SDL_DestroySemaphore (sdlBufferFull);
+  SDL_DestroySemaphore (sdlBufferEmpty);
+  sdlBufferLock  = NULL;
+  sdlBufferFull  = NULL;
+  sdlBufferEmpty = NULL;
 }
 
 void systemSoundPause()
diff -urN ../VisualBoyAdvance-1.7.2/src/sdl/TestEmu.cpp ./src/sdl/TestEmu.cpp
--- ../VisualBoyAdvance-1.7.2/src/sdl/TestEmu.cpp	2004-05-21 03:13:15 +0900
+++ ./src/sdl/TestEmu.cpp	2006-08-25 22:09:04 +0900
@@ -23,17 +23,18 @@
 #include <sys/types.h>
 #include <sys/stat.h>
 
-#include "AutoBuild.h"
+#include "../AutoBuild.h"
 
-#include "GBA.h"
+#include "../GBA.h"
 #include "debugger.h"
-#include "Sound.h"
-#include "unzip.h"
-#include "Util.h"
-#include "gb/GB.h"
-#include "gb/gbGlobals.h"
+#include "../Sound.h"
+#include "../unzip.h"
+#include "../Util.h"
+#include "../gb/GB.h"
+#include "../gb/gbGlobals.h"
+#include "../getopt.h"
 
-#ifndef WIN32
+#ifndef _WIN32
 # include <unistd.h>
 # define GETCWD getcwd
 #else // WIN32
@@ -255,7 +256,7 @@
     paletteRAM = (u8 *)calloc(1,0x400);
     vram = (u8 *)calloc(1, 0x20000);
     oam = (u8 *)calloc(1, 0x400);
-    pix = (u8 *)calloc(1, 4 * 240 * 160);
+    pix = (u8 *)calloc(1, 4 * 241 * 162);
     ioMem = (u8 *)calloc(1, 0x400);
 
     emulator = GBASystem;
@@ -352,6 +353,38 @@
 {
 }
 
+void sdlWriteState(int num)
+{
+  char stateName[2048];
+
+  if(saveDir[0])
+    sprintf(stateName, "%s/%s%d.sgm", saveDir, sdlGetFilename(filename),
+            num+1);
+  else
+    sprintf(stateName,"%s%d.sgm", filename, num+1);
+  if(emulator.emuWriteState)
+    emulator.emuWriteState(stateName);
+  sprintf(stateName, "Wrote state %d", num+1);
+  systemScreenMessage(stateName);
+}
+
+void sdlReadState(int num)
+{
+  char stateName[2048];
+
+  if(saveDir[0])
+    sprintf(stateName, "%s/%s%d.sgm", saveDir, sdlGetFilename(filename),
+            num+1);
+  else
+    sprintf(stateName,"%s%d.sgm", filename, num+1);
+
+  if(emulator.emuReadState)
+    emulator.emuReadState(stateName);
+
+  sprintf(stateName, "Loaded state %d", num+1);
+  systemScreenMessage(stateName);
+}
+
 void systemScreenCapture(int a)
 {
   char buffer[2048];
